class ActivityLog < ActiveRecord::Base

  serialize :data, Hash

  belongs_to :parent, class_name: 'ActivityLog', foreign_key: 'parent_activity_id'
  has_many :children, class_name: 'ActivityLog', foreign_key: 'parent_activity_id'
  belongs_to :loggable, polymorphic: true
  belongs_to :user

  validates :action_type, inclusion: {in: %w(model controller)}
end
