require 'activity_log/model_activity_logger'

module ControllerActivityLogger
  extend ActiveSupport::Concern

  def clear_parent_activity_id(options = {})
    ModelActivityLogger.current_parent_activity_id = nil
  end

  def record_activity_log(options = {})
    return unless params[options[:key] || :id].present?
    return if request.get? #exit if it's a get
    object = (options[:class] || controller_name).classify.constantize.find_by_id(params[options[:key] || :id])
    return unless object.present?
    return unless object.respond_to? :activity_logs

    data = params.deep_dup
    data[:password] = "[FILTERED]" if data[:password].present?

    ModelActivityLogger.current_parent_activity_id = object.activity_logs.create(user_id: current_user.try(:id), action: "#{data[:controller]}/#{data[:action]}", data: data, action_type: 'controller').id
  end

  # CLASS METHODS (self.)
  module ClassMethods
    def log_activity(options = {})
      self.before_filter {record_activity_log(options)}
      self.after_filter {clear_parent_activity_id(options)}
    end
  end
end