module ModelActivityLogger
  extend ActiveSupport::Concern

  mattr_accessor :current_parent_activity_id

  def record_activity_log(action)
    # if current_user_id == nil, then the User is in the process of Logging In
    current_id = defined?(current_user_id) ? current_user_id : nil
    activity_logs.create user_id: current_id, action: action, data: changes, action_type: 'model', parent_activity_id: current_parent_activity_id
  end

  module ClassMethods
    def log_activity
      self.has_many :activity_logs, as: :loggable
      self.after_create {record_activity_log("create")}
      self.after_update {record_activity_log("update")}
      self.before_destroy {record_activity_log("destroy")}
    end
  end
end